<template>
  <div class="hello">
    <input type="text" v-model="firstName">
    <input type="text" v-model="lastName">
    <button @click="onClick()">Click me</button>
    <button @click="addToCount(10)">Add to count</button>
    <br>
    <br>
    FullName: {{ fullName }}
    <ul>
      <li v-for="l in list" v-bind:key="l.name">
        {{ l.name }} - {{ l.age }}
      </li>
    </ul>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch, Emit } from "vue-property-decorator";

@Component
export default class HelloWorld extends Vue {
  firstName = "";
  lastName = "";
  
  private list: Array<object> = [
    {
      name: 'Preetish',
      age: '26'
    },
    {
      name: 'John',
      age: '30'
    }
  ]
  // computed
  get fullName(): string{
    return this.firstName + " " + this.lastName
  }
  set fullName(newValue: string){
    const names = newValue.split(" ");
    this.firstName = names[0];
    this.lastName = names[1]
  }
  // methods
  public onClick(): void{
    console.log('click');
    console.log(this.fullName);
  }
  // watch
  @Watch('firstName',
    { 
      immediate: true, deep: true 
  })
  firstNameChanged(newVal: string) {
    console.log(newVal);
  }
  @Emit()
  addToCount(n: number) {
    return n;
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">

</style>
